//+------------------------------------------------------------------+
//| ADX Crossing.mq4                                                 +
//| Author: Amir                                                     +
//| 20070623 - Modified by HerbertH (Add MPower rules filter, Alerts)+
//+------------------------------------------------------------------+
//mod di x adx 
//mod  fxtsd dms: adx di macd 
//http://www.forexfactory.com/showpost.php?p=2644494&postcount=10
//http://www.forexfactory.com/showthread.php?t=161278



#property  copyright "Author - Amir"

#property indicator_chart_window
#property indicator_buffers      2
#property indicator_width1       0
#property indicator_width2       0
#property indicator_color1       DeepSkyBlue
#property indicator_color2       Tomato

extern int     ADX_period          =  14;
extern int     DI_period           =  14;

extern int     adxLevelmin          =  20;
extern int     adxLevelmax          =  40;
extern int     diLevel              =  20;

extern int macdMAfast =12;  
extern int macdMAslow =26;  
extern int macdSigMA  =9;  




extern int     MaxBars           =  1000;
extern bool    UseAlert          =  false;//1

double   val1[],
         val2[],
         temp[],
         b4plusdi,
         nowplusdi,
         b4minusdi,
         nowminusdi,
         ADX0,
         ADX1;
bool     CrossUp,
         CrossDown;
string   AlertTXT;
datetime AlertBar,
         LastAlertBar;


int init()
{
   string short_name;
   IndicatorBuffers(3);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,233);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,234);

   SetIndexBuffer(0,val1);
   SetIndexBuffer(1,val2);
   SetIndexBuffer(2,temp);
   return(0);
}


int start()
{   
   int counted_bars=IndicatorCounted();
   
   if(counted_bars<0) counted_bars=0;
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   
   for (int shift=limit; shift>= 0; shift--)

   {
      b4plusdi    = iADX(NULL,0,DI_period,PRICE_CLOSE,MODE_PLUSDI,shift+1);
      nowplusdi   = iADX(NULL,0,DI_period,PRICE_CLOSE,MODE_PLUSDI,shift);
      b4minusdi   = iADX(NULL,0,DI_period,PRICE_CLOSE,MODE_MINUSDI,shift+1);
      nowminusdi  = iADX(NULL,0,DI_period,PRICE_CLOSE,MODE_MINUSDI,shift);
      ADX1        = iADX(NULL,0,ADX_period,PRICE_CLOSE,MODE_MAIN,shift+1);
      ADX0        = iADX(NULL,0,ADX_period,PRICE_CLOSE,MODE_MAIN,shift);


      double macdOsma0=iOsMA(NULL,0,macdMAfast,macdMAslow,macdSigMA,PRICE_CLOSE,shift); 
//    double macdOsma1=iOsMA(NULL,0,macdMAfast,macdMAslow,macdSigMA,PRICE_CLOSE,i+1); 



   CrossDown = false;   CrossUp   = false;

   
   val1[shift]=EMPTY_VALUE;   val2[shift]=EMPTY_VALUE;
   
   temp[shift]=temp[shift+1];


   if    (ADX0>adxLevelmin && ADX0<adxLevelmax && ADX0>ADX1 &&
          nowplusdi>nowminusdi && nowplusdi>diLevel &&
          macdOsma0>0   && temp[shift]!=1) 
     
         {
            val1[shift] = Low[shift]-10*Point;
            temp[shift] = 1;
            CrossUp   = true;
            AlertTXT    = ": DI,ADX,macd UP ";
            AlertBar    = Time[shift];
         }



   
   if    (ADX0>adxLevelmin && ADX0<adxLevelmax && ADX0>ADX1 &&
          nowminusdi>nowplusdi && nowminusdi>diLevel &&
          macdOsma0 < 0 && temp[shift]!=-1) 

         {
            val2[shift] = High[shift]+10*Point;
            temp[shift] = -1;
            CrossDown = true;
            AlertTXT    = " DI,ADX,macd DN ";
            AlertBar    = Time[shift];
         }
   
   if(  UseAlert && LastAlertBar!=AlertBar && CrossUp||CrossDown)
      {
         Alert(Symbol(), ",M", Period(), AlertTXT);
         LastAlertBar=AlertBar;
      }



   }
   return(0);
}